PING6(8)

NAME
ping6 - send ICMPv6 ECHO_REQUEST packets to network hosts

SYNOPSIS
ping6 [-dEefHLmnqv] [-c count] [-h hoplimit] [-I sourceaddr] [-i wait] [-l preload] [-p pattern] [-s packetsize] [-V rtable] [-w maxwait] host

DESCRIPTION
ping6 uses the ICMPv6 protocol's mandatory ICMP6_ECHO_REQUEST datagram to elicit an ICMP6_ECHO_REPLY from a host or gateway. ICMP6_ECHO_REQUEST datagrams (“pings”) have an IPv6 header, followed by an ICMPv6 header formatted as documented in RFC 4443. The options are as follows:

-c count
    Stop after sending (and receiving) count ECHO_RESPONSE packets. If count is 0, send an unlimited number of packets.

-d  Set the SO_DEBUG option on the socket being used.

-E  Emit an audible beep (by sending an ASCII BEL character to the standard error output) when no packet is received before the next packet is transmitted. To cater for round-trip times that are longer than the interval between transmissions, further missing packets cause a bell only if the maximum number of unreceived packets has increased. This option is disabled for flood pings.

-e  Emit an audible beep (by sending an ASCII BEL character to the standard error output) after each non-duplicate response is received. This option is disabled for flood pings.

-f  Flood ping. Outputs packets as fast as they come back or one hundred times per second, whichever is more. For every ECHO_REQUEST sent a period (‘’). is printed, while for every ECHO_REPLY received a backspace is printed. This provides a rapid display of how many packets are being dropped. Only the super-user may use this option. This can be very hard on a network and should be used with caution.

-H  Specifies to try reverse-lookup of IPv6 addresses. The ping6 command does not try reverse-lookup unless the option is specified.

-h hoplimit
    Set the IPv6 hoplimit.

-I sourceaddr
    Specifies the source address of request packets. The source address must be one of the unicast addresses of the sending node, and must be numeric.

-i wait
    Wait wait seconds between sending each packet. The default is to wait for one second between each packet. This option is incompatible with the -f option.

-L  Disable the loopback, so the transmitting host doesn't see ICMP requests. For multicast pings.

-l preload
    If preload is specified, ping6 sends that many packets as fast as possible before falling into its normal mode of behavior. Only the super-user may use this option.

-m  By default, ping6 asks the kernel to fragment packets to fit into the minimum IPv6 MTU. -m will suppress the behavior in the following two levels: when the option is specified once, the behavior will be disabled for unicast packets. When the option is specified more than once, it will be disabled for both unicast and multicast packets.

-n  Numeric output only. No attempt will be made to look up symbolic names from addresses in the reply.

-p pattern
    Up to 16 “pad” bytes may be specified to fill out the packet sent. This is useful for diagnosing data-dependent problems in a network. For example, “-p ff” will cause the packet sent to be filled with all ones.

-q  Quiet output. Nothing is displayed except the summary lines at startup time and when finished.

-s packetsize
    Specifies the number of data bytes to be sent. The default is 56, which translates into 64 ICMP data bytes when combined with the 8 bytes of ICMP header data.

    This option is ignored if any of the flags [-tWw] are specified.

-V rtable
    Set the routing table to be used for outgoing packets.

-v  Verbose output. All ICMP packets that are received are listed.

-w maxwait
    Specifies the maximum number of seconds to wait for responses after the last request has been sent. The default is 10.

When using ping6 for fault isolation, it should first be run on the local host, to verify that the local network interface is up and running. Then hosts and gateways further and further away can be “pinged”. Round-trip times and packet loss statistics are computed. If duplicate packets are received, they are not included in the packet loss calculation, although the round trip time of these packets is used in calculating the round-trip time statistics. When the specified number of packets have been sent (and received) or if the program is terminated with a SIGINT, a brief summary is displayed, showing the number of packets sent and received, and the minimum, maximum, mean, and standard deviation of the round-trip times.

This program is intended for use in network testing, measurement, and management. Because of the load it can impose on the network, it is unwise to use ping6 during normal operations or from automated scripts.

DUPLICATE AND DAMAGED PACKETS
ping6 will report duplicate and damaged packets. Duplicate packets should never occur when pinging a unicast address, and seem to be caused by inappropriate link-level retransmissions. Duplicates may occur in many situations and are rarely (if ever) a good sign, although the presence of low levels of duplicates may not always be cause for alarm. Duplicates are expected when pinging a broadcast or multicast address, since they are not really duplicates but replies from different hosts to the same request.

Damaged packets are obviously serious cause for alarm and often indicate broken hardware somewhere in the ping6 packet's path (in the network or in the hosts).

TRYING DIFFERENT DATA PATTERNS
The (inter)network layer should never treat packets differently depending on the data contained in the data portion. Unfortunately, data-dependent problems have been known to sneak into networks and remain undetected for long periods of time. In many cases the particular pattern that will have problems is something that does not have sufficient “transitions”, such as all ones or all zeros, or a pattern right at the edge, such as almost all zeros. It is not necessarily enough to specify a data pattern of all zeros (for example) on the command line because the pattern that is of interest is at the data link level, and the relationship between what is typed and what the controllers transmit can be complicated.

This means that if there is a data-dependent problem, a lot of testing will probably have to be done to find it. It may be possible to find a file that either cannot be sent across the network or that takes much longer to transfer than other similar length files. This file can then be examined for repeated patterns that can be tested using the -p option.

EXIT STATUS
ping6 exits 0 if at least one reply is received, and 0 if no reply is received or an error occurred.

EXAMPLES
Normally, ping6 works just like ping(8) would work; the following will send ICMPv6 echo requests to dst.foo.com:

    $ ping6 -n dst.foo.com

The following will send ICMPv6 echo requests to the link-local all-node multicast address. The packet reaches all nodes on the network link attached to the wi0 interface.

    $ ping6 ff02::1%wi0

SEE ALSO
netstat(1), icmp6(4), inet6(4), ip6(4), ifconfig(8), ping(8), route6d(8), traceroute6(8)

STANDARDS
A. Conta, S. Deering, M. Gupta, March 2006, RFC 4443, Internet Control Message Protocol (ICMPv6) for the Internet Protocol Version 6 (IPv6) Specification.

HISTORY
The ping(8) command first appeared in 4.3BSD. The ping6 command with IPv6 support first appeared in the WIDE Hydrangea IPv6 protocol stack kit.

BUGS
ping6 is intentionally separate from ping(8).